diff --git a/tensorflow/workspace.bzl b/tensorflow/workspace.bzl
index 0616aa91fa6..a258abb3948 100755
--- a/tensorflow/workspace.bzl
+++ b/tensorflow/workspace.bzl
@@ -157,6 +157,7 @@ def tf_repositories(path_prefix = "", tf_repo_name = ""):
     tf_http_archive(
         name = "com_google_absl",
         build_file = clean_dep("//third_party:com_google_absl.BUILD"),
+        patch_file = clean_dep("//third_party:com_google_absl.patch"),
         sha256 = "acd93f6baaedc4414ebd08b33bebca7c7a46888916101d8c0b8083573526d070",
         strip_prefix = "abseil-cpp-43ef2148c0936ebf7cb4be6b19927a9d9d145b8f",
         urls = [
@@ -215,6 +216,7 @@ def tf_repositories(path_prefix = "", tf_repo_name = ""):
         sha256 = "fd0c3e3b50f32af332b53857f8cd1bfa009e33d1eeecabc5c79a4825d906a90c",
         strip_prefix = "google-cloud-cpp-0.10.0",
         system_build_file = clean_dep("//third_party/systemlibs:google_cloud_cpp.BUILD"),
+	patch_file = "//third_party:google_cloud_cpp.patch",
         system_link_files = {
             "//third_party/systemlibs:google_cloud_cpp.google.cloud.bigtable.BUILD": "google/cloud/bigtable/BUILD",
         },
@@ -370,7 +372,8 @@ def tf_repositories(path_prefix = "", tf_repo_name = ""):
         name = "absl_py",
         sha256 = "3d0f39e0920379ff1393de04b573bca3484d82a5f8b939e9e83b20b6106c9bbe",
         strip_prefix = "abseil-py-pypi-v0.7.1",
-        system_build_file = clean_dep("//third_party/systemlibs:absl_py.BUILD"),
+        patch_file = clean_dep("//third_party/systemlibs:absl_py.patch"),
+	system_build_file = clean_dep("//third_party/systemlibs:absl_py.BUILD"),
         system_link_files = {
             "//third_party/systemlibs:absl_py.absl.BUILD": "absl/BUILD",
             "//third_party/systemlibs:absl_py.absl.flags.BUILD": "absl/flags/BUILD",
@@ -434,7 +437,7 @@ def tf_repositories(path_prefix = "", tf_repo_name = ""):
         sha256 = PROTOBUF_SHA256,
         strip_prefix = PROTOBUF_STRIP_PREFIX,
         system_build_file = clean_dep("//third_party/systemlibs:protobuf.BUILD"),
-        system_link_files = {
+	system_link_files = {
             "//third_party/systemlibs:protobuf.bzl": "protobuf.bzl",
         },
         urls = PROTOBUF_URLS,
@@ -472,27 +475,27 @@ def tf_repositories(path_prefix = "", tf_repo_name = ""):
     )
 
     tf_http_archive(
-        name = "pcre",
-        build_file = clean_dep("//third_party:pcre.BUILD"),
-        sha256 = "aecafd4af3bd0f3935721af77b889d9024b2e01d96b58471bd91a3063fb47728",
-        strip_prefix = "pcre-8.44",
-        system_build_file = clean_dep("//third_party/systemlibs:pcre.BUILD"),
+        name = "pcre2",
+        build_file = clean_dep("//third_party:pcre2.BUILD"),
+        sha256 = "409c443549b13b216da40049850a32f3e6c57d4224ab11553ab5a786878a158e",
+        strip_prefix = "pcre2-pcre2-10.47",
+        system_build_file = clean_dep("//third_party/systemlibs:pcre2.BUILD"),
         urls = [
-            "https://storage.googleapis.com/mirror.tensorflow.org/ftp.exim.org/pub/pcre/pcre-8.44.tar.gz",
-            "https://ftp.exim.org/pub/pcre/pcre-8.44.tar.gz",
+            "https://storage.googleapis.com/mirror.tensorflow.org/github.com/PCRE2Project/pcre2/archive//pcre2-10.47.tar.gz",
+	    "https://github.com/PCRE2Project/pcre2/archive//pcre2-10.47.tar.gz"
         ],
     )
 
     tf_http_archive(
         name = "swig",
         build_file = clean_dep("//third_party:swig.BUILD"),
-        sha256 = "58a475dbbd4a4d7075e5fe86d4e54c9edde39847cdb96a3053d87cb64a23a453",
-        strip_prefix = "swig-3.0.8",
+        sha256 = "40162a706c56f7592d08fd52ef5511cb7ac191f3593cf07306a0a554c6281fcf",
+        strip_prefix = "swig-4.4.1",
         system_build_file = clean_dep("//third_party/systemlibs:swig.BUILD"),
         urls = [
-            "https://storage.googleapis.com/mirror.tensorflow.org/ufpr.dl.sourceforge.net/project/swig/swig/swig-3.0.8/swig-3.0.8.tar.gz",
-            "http://ufpr.dl.sourceforge.net/project/swig/swig/swig-3.0.8/swig-3.0.8.tar.gz",
-            "http://pilotfiber.dl.sourceforge.net/project/swig/swig/swig-3.0.8/swig-3.0.8.tar.gz",
+            "https://storage.googleapis.com/mirror.tensorflow.org/ufpr.dl.sourceforge.net/project/swig/swig/swig-4.4.1/swig-4.4.1.tar.gz",
+            "http://ufpr.dl.sourceforge.net/project/swig/swig/swig-4.4.1/swig-4.4.1.tar.gz",
+            "http://pilotfiber.dl.sourceforge.net/project/swig/swig/swig-4.4.1/swig-4.4.1.tar.gz",
         ],
     )
 
@@ -514,6 +517,7 @@ def tf_repositories(path_prefix = "", tf_repo_name = ""):
         sha256 = "67a6c26db56f345f7cee846e681db2c23f919eba46dd639b09462d1b6203d28c",
         strip_prefix = "grpc-4566c2a29ebec0835643b972eb99f4306c4234a3",
         system_build_file = clean_dep("//third_party/systemlibs:grpc.BUILD"),
+	patch_file = clean_dep("//third_party/systemlibs:grpc.patch"),
         urls = [
             "https://storage.googleapis.com/mirror.tensorflow.org/github.com/grpc/grpc/archive/4566c2a29ebec0835643b972eb99f4306c4234a3.tar.gz",
             "https://github.com/grpc/grpc/archive/4566c2a29ebec0835643b972eb99f4306c4234a3.tar.gz",
@@ -584,6 +588,7 @@ def tf_repositories(path_prefix = "", tf_repo_name = ""):
         sha256 = "1188e29000013ed6517168600fc35a010d58c5d321846d6a6dfee74e4c788b45",
         strip_prefix = "boringssl-7f634429a04abc48e2eb041c81c5235816c96514",
         system_build_file = clean_dep("//third_party/systemlibs:boringssl.BUILD"),
+        patch_file = clean_dep("//third_party/boringssl:patch"),
         urls = [
             "https://storage.googleapis.com/mirror.tensorflow.org/github.com/google/boringssl/archive/7f634429a04abc48e2eb041c81c5235816c96514.tar.gz",
             "https://github.com/google/boringssl/archive/7f634429a04abc48e2eb041c81c5235816c96514.tar.gz",
@@ -728,17 +733,6 @@ def tf_repositories(path_prefix = "", tf_repo_name = ""):
         ],
     )
 
-    tf_http_archive(
-        name = "cub_archive",
-        build_file = clean_dep("//third_party:cub.BUILD"),
-        sha256 = "6bfa06ab52a650ae7ee6963143a0bbc667d6504822cbd9670369b598f18c58c3",
-        strip_prefix = "cub-1.8.0",
-        urls = [
-            "https://storage.googleapis.com/mirror.tensorflow.org/github.com/NVlabs/cub/archive/1.8.0.zip",
-            "https://github.com/NVlabs/cub/archive/1.8.0.zip",
-        ],
-    )
-
     tf_http_archive(
         name = "rocprim_archive",
         build_file = clean_dep("//third_party:rocprim.BUILD"),
@@ -754,12 +748,12 @@ def tf_repositories(path_prefix = "", tf_repo_name = ""):
         name = "cython",
         build_file = clean_dep("//third_party:cython.BUILD"),
         delete = ["BUILD.bazel"],
-        sha256 = "bccc9aa050ea02595b2440188813b936eaf345e85fb9692790cecfe095cf91aa",
-        strip_prefix = "cython-0.28.4",
+        sha256 = "824eb14045d85c5af677536134199dd6709db8fb0835452fd2d54bc3c8df8887",
+        strip_prefix = "cython-0.29.37",
         system_build_file = clean_dep("//third_party/systemlibs:cython.BUILD"),
         urls = [
-            "https://storage.googleapis.com/mirror.tensorflow.org/github.com/cython/cython/archive/0.28.4.tar.gz",
-            "https://github.com/cython/cython/archive/0.28.4.tar.gz",
+            "https://mirror.bazel.build/github.com/cython/cython/archive/0.29.37.tar.gz",
+            "https://github.com/cython/cython/archive/0.29.37.tar.gz",
         ],
     )
 
@@ -925,23 +919,23 @@ def tf_repositories(path_prefix = "", tf_repo_name = ""):
     tf_http_archive(
         name = "pybind11",
         urls = [
-            "https://mirror.bazel.build/github.com/pybind/pybind11/archive/v2.3.0.tar.gz",
-            "https://github.com/pybind/pybind11/archive/v2.3.0.tar.gz",
+            "https://mirror.bazel.build/github.com/pybind/pybind11/archive/v2.13.6.tar.gz",
+            "https://github.com/pybind/pybind11/archive/v2.13.6.tar.gz",
         ],
-        sha256 = "0f34838f2c8024a6765168227ba587b3687729ebf03dc912f88ff75c7aa9cfe8",
-        strip_prefix = "pybind11-2.3.0",
+        sha256 = "e08cb87f4773da97fa7b5f035de8763abc656d87d5773e62f6da0587d1f0ec20",
+        strip_prefix = "pybind11-2.13.6",
         build_file = clean_dep("//third_party:pybind11.BUILD"),
     )
 
     tf_http_archive(
         name = "wrapt",
         build_file = clean_dep("//third_party:wrapt.BUILD"),
-        sha256 = "8a6fb40e8f8b6a66b4ba81a4044c68e6a7b1782f21cfabc06fb765332b4c3e51",
-        strip_prefix = "wrapt-1.11.1/src/wrapt",
+        sha256 = "9f289d4a27cb94eaa4ecf91cdcdb2508ba38db655ba3f43e018f88e1750b8915",
+        strip_prefix = "wrapt-2.1.2/src/wrapt",
         system_build_file = clean_dep("//third_party/systemlibs:wrapt.BUILD"),
         urls = [
-            "https://storage.googleapis.com/mirror.tensorflow.org/github.com/GrahamDumpleton/wrapt/archive/1.11.1.tar.gz",
-            "https://github.com/GrahamDumpleton/wrapt/archive/1.11.1.tar.gz",
+            "https://storage.googleapis.com/mirror.tensorflow.org/github.com/GrahamDumpleton/wrapt/archive/2.1.2.tar.gz",
+            "https://github.com/GrahamDumpleton/wrapt/archive/2.1.2.tar.gz",
         ],
     )
 
diff --git a/third_party/aws/workspace.bzl b/third_party/aws/workspace.bzl
index f37699e34c5..811ca23d719 100644
--- a/third_party/aws/workspace.bzl
+++ b/third_party/aws/workspace.bzl
@@ -15,4 +15,5 @@ def repo():
         sha256 = "89905075fe50aa13e0337ff905c2e8c1ce9caf77a3504484a7cda39179120ffc",
         strip_prefix = "aws-sdk-cpp-1.5.8",
         build_file = "//third_party/aws:BUILD.bazel",
+	patch_file = "//third_party/aws:aws.patch",
     )
diff --git a/third_party/boringssl/patch b/third_party/boringssl/patch
new file mode 100644
index 00000000000..6adfab1e4be
--- /dev/null
+++ b/third_party/boringssl/patch
@@ -0,0 +1,61 @@
+--- boringssl/src/crypto/x509/t_x509.org.c	2026-04-28 16:32:42.664037294 +0000
++++ boringssl/src/crypto/x509/t_x509.c	2026-04-28 16:34:56.391899068 +0000
+@@ -500,9 +500,7 @@
+ int X509_NAME_print(BIO *bp, X509_NAME *name, int obase)
+ {
+     char *s, *c, *b;
+-    int ret = 0, l, i;
+-
+-    l = 80 - 2 - obase;
++    int ret = 0, i;
+ 
+     b = X509_NAME_oneline(name, NULL, 0);
+     if (!b)
+@@ -529,12 +527,10 @@
+                 if (BIO_write(bp, ", ", 2) != 2)
+                     goto err;
+             }
+-            l--;
+         }
+         if (*s == '\0')
+             break;
+         s++;
+-        l--;
+     }
+ 
+     ret = 1;
+--- boringssl/src/third_party/fiat/curve25519.org.c	2026-04-28 18:08:53.752703283 +0000
++++ boringssl/src/third_party/fiat/curve25519.c	2026-04-28 18:11:07.433554030 +0000
+@@ -1902,7 +1902,7 @@
+ //
+ // Preconditions:
+ //   a[31] <= 127
+-void x25519_ge_scalarmult_base(ge_p3 *h, const uint8_t *a) {
++void x25519_ge_scalarmult_base(ge_p3 *h, const uint8_t a[32]) {
+   signed char e[64];
+   signed char carry;
+   ge_p1p1 r;
+--- boringssl/src/crypto/fipsmodule/bn/internal.org.h	2026-04-29 06:30:13.414347370 +0000
++++ boringssl/src/crypto/fipsmodule/bn/internal.h	2026-04-29 06:30:31.495865508 +0000
+@@ -285,7 +285,7 @@
+ void bn_mul_comba8(BN_ULONG r[16], const BN_ULONG a[8], const BN_ULONG b[8]);
+ 
+ // bn_sqr_comba8 sets |r| to |a|^2.
+-void bn_sqr_comba8(BN_ULONG r[16], const BN_ULONG a[4]);
++void bn_sqr_comba8(BN_ULONG r[16], const BN_ULONG a[8]);
+ 
+ // bn_sqr_comba4 sets |r| to |a|^2.
+ void bn_sqr_comba4(BN_ULONG r[8], const BN_ULONG a[4]);
+--- boringssl/src/crypto/bytestring/cbb.org.c	2018-08-11 01:30:56.000000000 +0900
++++ boringssl/src/crypto/bytestring/cbb.c	2026-05-03 21:58:22.586746285 +0900
+@@ -23,6 +23,9 @@
+ 
+ #include "../internal.h"
+ 
++#if defined(__GNUC__) && (__GNUC__ >= 12)
++    #pragma GCC diagnostic ignored "-Wdangling-pointer"
++#endif
+ 
+ void CBB_zero(CBB *cbb) {
+   OPENSSL_memset(cbb, 0, sizeof(CBB));
+
diff --git a/third_party/gpus/crosstool/cc_toolchain_config.bzl.tpl b/third_party/gpus/crosstool/cc_toolchain_config.bzl.tpl
index 282ba08cda5..1ca6ba12908 100644
--- a/third_party/gpus/crosstool/cc_toolchain_config.bzl.tpl
+++ b/third_party/gpus/crosstool/cc_toolchain_config.bzl.tpl
@@ -1248,12 +1248,12 @@ def _impl(ctx):
         ],
     )
 
-    cpp11_feature = feature(
-        name = "c++11",
+    cpp14_feature = feature(
+        name = "c++14",
         flag_sets = [
             flag_set(
                 actions = [ACTION_NAMES.cpp_compile],
-                flag_groups = [flag_group(flags = ["-std=c++11"])],
+                flag_groups = [flag_group(flags = ["-std=c++14"])],
             ),
         ],
     )
@@ -1263,7 +1263,7 @@ def _impl(ctx):
             name = "common",
             implies = [
                 "stdlib",
-                "c++11",
+                "c++14",
                 "determinism",
                 "alwayslink",
                 "hardening",
@@ -1279,7 +1279,7 @@ def _impl(ctx):
             name = "common",
             implies = [
                 "stdlib",
-                "c++11",
+                "c++14",
                 "determinism",
                 "hardening",
                 "warnings",
@@ -1294,7 +1294,7 @@ def _impl(ctx):
 
     if (ctx.attr.cpu == "local"):
         features = [
-            cpp11_feature,
+            cpp14_feature,
             stdlib_feature,
             determinism_feature,
             alwayslink_feature,
@@ -1315,7 +1315,7 @@ def _impl(ctx):
         ]
     elif (ctx.attr.cpu == "darwin"):
         features = [
-            cpp11_feature,
+            cpp14_feature,
             stdlib_feature,
             determinism_feature,
             pic_feature,
diff --git a/third_party/gpus/crosstool/clang/bin/crosstool_wrapper_driver_is_not_gcc.tpl b/third_party/gpus/crosstool/clang/bin/crosstool_wrapper_driver_is_not_gcc.tpl
index a69be47945b..9548b756211 100755
--- a/third_party/gpus/crosstool/clang/bin/crosstool_wrapper_driver_is_not_gcc.tpl
+++ b/third_party/gpus/crosstool/clang/bin/crosstool_wrapper_driver_is_not_gcc.tpl
@@ -43,7 +43,7 @@ import os
 import subprocess
 import re
 import sys
-import pipes
+import shlex
 
 # Template values set by cuda_autoconf.
 CPU_COMPILER = ('%{cpu_compiler}')
@@ -170,7 +170,7 @@ def InvokeNvcc(argv, log=False):
   undefines = ''.join([' -U' + define for define in undefines])
   std_options = GetOptionValue(argv, 'std')
   # currently only c++11 is supported by Cuda 7.0 std argument
-  nvcc_allowed_std_options = ["c++11"]
+  nvcc_allowed_std_options = ["c++14"]
   std_options = ''.join([' -std=' + define
       for define in std_options if define in nvcc_allowed_std_options])
 
@@ -249,7 +249,7 @@ def main():
 
   if args.x and args.x[0] == 'cuda':
     if args.cuda_log: Log('-x cuda')
-    leftover = [pipes.quote(s) for s in leftover]
+    leftover = [shlex.quote(s) for s in leftover]
     if args.cuda_log: Log('using nvcc')
     return InvokeNvcc(leftover, log=args.cuda_log)
 
diff --git a/third_party/gpus/cuda_configure.bzl b/third_party/gpus/cuda_configure.bzl
index cf63adcbaa2..dfb23daa442 100644
--- a/third_party/gpus/cuda_configure.bzl
+++ b/third_party/gpus/cuda_configure.bzl
@@ -617,14 +617,14 @@ def _find_libs(repository_ctx, cuda_config):
             repository_ctx,
             cpu_value,
             cuda_config.config["cuda_library_dir"],
-            cuda_config.cuda_version,
+            None,
         ),
         "cudart_static": _find_cuda_lib(
             "cudart_static",
             repository_ctx,
             cpu_value,
             cuda_config.config["cuda_library_dir"],
-            cuda_config.cuda_version,
+            None,
             static = True,
         ),
         "cublas": _find_cuda_lib(
@@ -632,49 +632,49 @@ def _find_libs(repository_ctx, cuda_config):
             repository_ctx,
             cpu_value,
             cuda_config.config["cublas_library_dir"],
-            cuda_config.cuda_lib_version,
+            None,
         ),
         "cusolver": _find_cuda_lib(
             "cusolver",
             repository_ctx,
             cpu_value,
             cuda_config.config["cuda_library_dir"],
-            cuda_config.cuda_lib_version,
+            None,
         ),
         "curand": _find_cuda_lib(
             "curand",
             repository_ctx,
             cpu_value,
             cuda_config.config["cuda_library_dir"],
-            cuda_config.cuda_lib_version,
+            None,
         ),
         "cufft": _find_cuda_lib(
             "cufft",
             repository_ctx,
             cpu_value,
             cuda_config.config["cuda_library_dir"],
-            cuda_config.cuda_lib_version,
+            None,
         ),
         "cudnn": _find_cuda_lib(
             "cudnn",
             repository_ctx,
             cpu_value,
             cuda_config.config["cudnn_library_dir"],
-            cuda_config.cudnn_version,
+            None,
         ),
         "cupti": _find_cuda_lib(
             "cupti",
             repository_ctx,
             cpu_value,
             cuda_config.config["cupti_library_dir"],
-            cuda_config.cuda_version,
+            None,
         ),
         "cusparse": _find_cuda_lib(
             "cusparse",
             repository_ctx,
             cpu_value,
             cuda_config.config["cuda_library_dir"],
-            cuda_config.cuda_lib_version,
+            None,
         ),
     }
 
@@ -1053,8 +1053,26 @@ def _create_local_cuda_repository(repository_ctx):
     copy_rules.append(make_copy_files_rule(
         repository_ctx,
         name = "cudnn-include",
-        srcs = [cudnn_header_dir + "/cudnn.h"],
-        outs = ["cudnn/include/cudnn.h"],
+        srcs = [
+			cudnn_header_dir + "/cudnn.h",
+			cudnn_header_dir + "/cudnn_ops_infer.h",
+			cudnn_header_dir + "/cudnn_ops_train.h",
+			cudnn_header_dir + "/cudnn_adv_infer.h",
+			cudnn_header_dir + "/cudnn_adv_train.h",
+			cudnn_header_dir + "/cudnn_cnn_infer.h",
+			cudnn_header_dir + "/cudnn_cnn_train.h",
+			cudnn_header_dir + "/cudnn_backend.h",
+		],
+        outs = [
+			"cudnn/include/cudnn.h",
+			"cudnn/include/cudnn_ops_infer.h",
+			"cudnn/include/cudnn_ops_train.h",
+			"cudnn/include/cudnn_adv_infer.h",
+			"cudnn/include/cudnn_adv_train.h",
+			"cudnn/include/cudnn_cnn_infer.h",
+			"cudnn/include/cudnn_cnn_train.h",
+			"cudnn/include/cudnn_backend.h",
+		],
     ))
 
     # Set up BUILD file for cuda/
@@ -1159,7 +1177,7 @@ def _create_local_cuda_repository(repository_ctx):
         # .d file - given that includes that are prefixed with "../" multiple
         # time quickly grow longer than the root of the tree, this can lead to
         # bazel's header check failing.
-        cuda_defines["%{extra_no_canonical_prefixes_flags}"] = "\"-fno-canonical-system-headers\""
+        #cuda_defines["%{extra_no_canonical_prefixes_flags}"] = "\"-fno-canonical-system-headers\""
 
         nvcc_path = str(
             repository_ctx.path("%s/nvcc%s" % (
diff --git a/third_party/gpus/find_cuda_config.py b/third_party/gpus/find_cuda_config.py
index be59515661a..2bae2d1d2f7 100644
--- a/third_party/gpus/find_cuda_config.py
+++ b/third_party/gpus/find_cuda_config.py
@@ -344,7 +344,7 @@ def _find_cudnn_config(base_paths, required_version):
         for name in ("CUDNN_MAJOR", "CUDNN_MINOR", "CUDNN_PATCHLEVEL"))
     return ".".join(version)
 
-  header_path, header_version = _find_header(base_paths, "cudnn.h",
+  header_path, header_version = _find_header(base_paths, "cudnn_version.h",
                                              required_version,
                                              get_header_version)
   cudnn_version = header_version.split(".")[0]
diff --git a/third_party/hwloc/patch b/third_party/hwloc/patch
new file mode 100644
index 00000000000..15d146472db
--- /dev/null
+++ b/third_party/hwloc/patch
@@ -0,0 +1,15 @@
+--- hwloc/hwloc/topology.org.c	2026-05-02 16:04:16.438684110 +0000
++++ hwloc/hwloc/topology.c	2026-05-02 16:05:55.729487835 +0000
+@@ -42,8 +42,12 @@
+ #endif
+ 
+ #ifdef HAVE_SYS_SYSCTL_H
++#if __GLIBC_PREREQ(2, 32)
++#include <linux/sysctl.h>
++#else
+ #include <sys/sysctl.h>
+ #endif
++#endif
+ 
+ #ifdef HWLOC_WIN_SYS
+ #include <windows.h>
diff --git a/third_party/hwloc/workspace.bzl b/third_party/hwloc/workspace.bzl
index dc8e1579e9c..2501baecf88 100644
--- a/third_party/hwloc/workspace.bzl
+++ b/third_party/hwloc/workspace.bzl
@@ -12,5 +12,6 @@ def repo():
         sha256 = "64def246aaa5b3a6e411ce10932a22e2146c3031b735c8f94739534f06ad071c",
         strip_prefix = "hwloc-2.0.3",
         build_file = "//third_party/hwloc:BUILD.bazel",
+	patch_file = "//third_party/hwloc:patch",
         system_build_file = "//third_party/hwloc:BUILD.system",
     )
diff --git a/third_party/mlir/include/mlir/Support/STLExtras.h b/third_party/mlir/include/mlir/Support/STLExtras.h
index 3448b080d03..64ac556d61e 100644
--- a/third_party/mlir/include/mlir/Support/STLExtras.h
+++ b/third_party/mlir/include/mlir/Support/STLExtras.h
@@ -26,6 +26,7 @@
 #include "mlir/Support/LLVM.h"
 #include "llvm/ADT/iterator.h"
 #include <tuple>
+#include <cstdint>
 
 namespace mlir {
 
diff --git a/third_party/nccl/build_defs.bzl.tpl b/third_party/nccl/build_defs.bzl.tpl
index 57191398553..5f5c3a1008a 100644
--- a/third_party/nccl/build_defs.bzl.tpl
+++ b/third_party/nccl/build_defs.bzl.tpl
@@ -113,7 +113,6 @@ def _device_link_impl(ctx):
             "--cmdline=--compile-only",
             "--link",
             "--compress-all",
-            "--bin2c-path=%s" % bin2c.dirname,
             "--create=%s" % tmp_fatbin.path,
             "--embedded-fatbin=%s" % fatbin_h.path,
         ] + images,
diff --git a/third_party/pcre2.BUILD b/third_party/pcre2.BUILD
index 3a8e7a10b43..1760ffa7245 100644
--- a/third_party/pcre2.BUILD
+++ b/third_party/pcre2.BUILD
@@ -1,38 +1,19 @@
 licenses(["notice"])  # BSD
 
-exports_files(["LICENCE"])
+exports_files(["LICENCE.md"])
 
 cc_library(
-    name = "pcre",
-    srcs = [
-        "pcre_byte_order.c",
-        "pcre_chartables.c",
-        "pcre_compile.c",
-        "pcre_config.c",
-        "pcre_dfa_exec.c",
-        "pcre_exec.c",
-        "pcre_fullinfo.c",
-        "pcre_get.c",
-        "pcre_globals.c",
-        "pcre_internal.h",
-        "pcre_jit_compile.c",
-        "pcre_maketables.c",
-        "pcre_newline.c",
-        "pcre_ord2utf8.c",
-        "pcre_refcount.c",
-        "pcre_string_utils.c",
-        "pcre_study.c",
-        "pcre_tables.c",
-        "pcre_ucd.c",
-        "pcre_valid_utf8.c",
-        "pcre_version.c",
-        "pcre_xclass.c",
-        "ucp.h",
-    ],
-    hdrs = [
-        "pcre.h",
-        "pcreposix.h",
-    ],
+    name = "pcre2",
+    srcs = glob([
+        "src/*.c",
+    ], exclude=[
+	"src/pcre2posix_test.c",
+	"src/pcre2test.c",
+	"src/pcre2_jit_test.c",
+	"src/pcre2_dftables.c",
+	"src/pcre2demo.c",
+	"src/pcre2grep.c",
+    ]) + ["src/pcre2_chartables.c"],
     copts = [
         "-DHAVE_BCOPY=1",
         "-DHAVE_INTTYPES_H=1",
@@ -44,37 +25,58 @@ cc_library(
         "-DHAVE_UNISTD_H=1",
         "-DLINK_SIZE=2",
         "-DMATCH_LIMIT=10000000",
+	"-DMATCH_LIMIT_DEPTH=10000000",
         "-DMATCH_LIMIT_RECURSION=1000",
         "-DMAX_NAME_COUNT=10000",
         "-DMAX_NAME_SIZE=32",
         "-DNEWLINE=10",
+	"-DNEWLINE_DEFAULT=2",
         "-DNO_RECURSE",
         "-DPARENS_NEST_LIMIT=50",
         "-DPOSIX_MALLOC_THRESHOLD=10",
+	"-DHEAP_LIMIT=20000000",
+	"-DMAX_VARLOOKBEHIND=255",
+	"-DPCRE2GREP_BUFSIZE=20480",
+        "-DPCRE2GREP_MAX_BUFSIZE=1048576",
         "-DSTDC_HEADERS=1",
         "-DSUPPORT_UCP",
         "-DSUPPORT_UTF",
+	"-DSUPPORT_PCRE2_8",
+        "-DSUPPORT_UNICODE",
+    ],
+    defines = [
+    	"PCRE2_STATIC=1",
+	"PCRE2_CODE_UNIT_WIDTH=8",
+	"PCRE2_EXPORT='__attribute__ ((visibility (\"default\")))'",
     ],
-    defines = ["PCRE_STATIC=1"],
-    includes = ["."],
+    deps = [":config"],
+    includes = ["src"],
     visibility = ["@swig//:__pkg__"],  # Please use RE2
     alwayslink = 1,
 )
 
+cc_library(
+    name = "config",
+    hdrs = ["src/pcre2.h"],
+    srcs = [":pcre_h"],
+    includes = ["src"],
+    visibility = ["//visibility:public"],
+)
+
 genrule(
     name = "pcre_h",
-    srcs = ["pcre.h.in"],
-    outs = ["pcre.h"],
-    cmd = "sed -e s/@PCRE_MAJOR@/8/" +
-          "    -e s/@PCRE_MINOR@/39/" +
-          "    -e s/@PCRE_PRERELEASE@//" +
-          "    -e s/@PCRE_DATE@/redacted/" +
+    srcs = ["src/pcre2.h.in"],
+    outs = ["src/pcre2.h"],
+    cmd = "sed -e s/@PCRE2_MAJOR@/10/" +
+          "    -e s/@PCRE2_MINOR@/47/" +
+          "    -e s/@PCRE2_PRERELEASE@//" +
+          "    -e s/@PCRE2_DATE@/redacted/" +
           "    $< >$@",
 )
 
 genrule(
     name = "pcre_chartables_c",
-    srcs = ["pcre_chartables.c.dist"],
-    outs = ["pcre_chartables.c"],
+    srcs = ["src/pcre2_chartables.c.dist"],
+    outs = ["src/pcre2_chartables.c"],
     cmd = "cp $< $@",
 )
diff --git a/third_party/py/python_configure.bzl b/third_party/py/python_configure.bzl
index d1b1e594921..788cc4d3b42 100644
--- a/third_party/py/python_configure.bzl
+++ b/third_party/py/python_configure.bzl
@@ -244,8 +244,8 @@ def _get_python_include(repository_ctx, python_bin):
             python_bin,
             "-c",
             "from __future__ import print_function;" +
-            "from distutils import sysconfig;" +
-            "print(sysconfig.get_python_inc())",
+            "import os, sysconfig;" +
+            "print(os.path.dirname(sysconfig.get_config_h_filename()))",
         ],
         error_msg = "Problem getting python include path.",
         error_details = ("Is the Python binary path set up right? " +
